Index: /trunk/src/VBox/Frontends/VirtualBox/src/extensionpackmanager/UIExtensionPackManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extensionpackmanager/UIExtensionPackManager.cpp	(revision 100729)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extensionpackmanager/UIExtensionPackManager.cpp	(revision 100730)
@@ -45,4 +45,5 @@
 #include "UIMessageCenter.h"
 #include "UINotificationCenter.h"
+#include "UIVirtualBoxEventHandler.h"
 
 /* COM includes: */
@@ -386,4 +387,6 @@
     uiCommon().setHelpKeyword(this, "ext-pack-manager");
     connect(&uiCommon(), &UICommon::sigExtensionPackInstalled,
+            this, &UIExtensionPackManagerWidget::sltHandleExtensionPackInstalled);
+    connect(gVBoxEvents, &UIVirtualBoxEventHandler::sigExtensionPackInstalled,
             this, &UIExtensionPackManagerWidget::sltHandleExtensionPackInstalled);
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMainEventListener.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMainEventListener.cpp	(revision 100729)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMainEventListener.cpp	(revision 100730)
@@ -630,5 +630,5 @@
         {
             CExtPackInstalledEvent comEventSpecific(pEvent);
-            //printf("Ext. pack installed from the file: %s\n", qPrintable(comEventSpecific.GetFilename()));
+            emit sigExtensionPackInstalled(comEventSpecific.GetName());
         };
         default: break;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMainEventListener.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMainEventListener.h	(revision 100729)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMainEventListener.h	(revision 100730)
@@ -123,4 +123,6 @@
         /** Notifies about cloud profile with specified @a strName of provider with specified @a uProviderId is changed. */
         void sigCloudProfileChanged(const QUuid &uProviderId, const QString &strName);
+        /** Notifies about ext.pack installation @a strname is the name of the installed ext. pack. */
+        void sigExtensionPackInstalled(const QString &strName);
     /** @} */
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIVirtualBoxEventHandler.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIVirtualBoxEventHandler.cpp	(revision 100729)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIVirtualBoxEventHandler.cpp	(revision 100730)
@@ -90,4 +90,7 @@
       * @param  fRegistered    Brings whether medium is registered or unregistered. */
     void sigMediumRegistered(const QUuid &uMediumId, KDeviceType enmMediumType, bool fRegistered);
+    /** Notifies extension pack. install.
+     *  @param  strName      Passes extension pack name. */
+    void sigExtensionPackInstalled(const QString &strName);
 
 public:
@@ -256,4 +259,7 @@
             this, SIGNAL(sigMediumRegistered(QUuid, KDeviceType, bool)),
             Qt::DirectConnection);
+    connect(m_pQtListener->getWrapped(), SIGNAL(sigExtensionPackInstalled(QString)),
+            this, SIGNAL(sigExtensionPackInstalled(QString)),
+            Qt::DirectConnection);
 }
 
@@ -377,4 +383,7 @@
             this, SIGNAL(sigMediumRegistered(QUuid, KDeviceType, bool)),
             Qt::QueuedConnection);
+    connect(m_pProxy, SIGNAL(sigExtensionPackInstalled(QString)),
+            this, SIGNAL(sigExtensionPackInstalled(QString)),
+            Qt::QueuedConnection);
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIVirtualBoxEventHandler.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIVirtualBoxEventHandler.h	(revision 100729)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIVirtualBoxEventHandler.h	(revision 100730)
@@ -98,4 +98,7 @@
       * @param  fRegistered    Brings whether medium is registered or unregistered. */
     void sigMediumRegistered(const QUuid &uMediumId, KDeviceType enmMediumType, bool fRegistered);
+    /** Notifies extension pack. install.
+     *  @param  strName      Passes extension pack name. */
+    void sigExtensionPackInstalled(const QString &strName);
 
 public:
Index: /trunk/src/VBox/Main/idl/VirtualBox.xidl
===================================================================
--- /trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 100729)
+++ /trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 100730)
@@ -26919,5 +26919,5 @@
     <const name="OnExtPackInstalled" value="123">
       <desc>
-        See <link to="IClipboardErrorEvent">IClipboardErrorEvent</link>.
+        See <link to="IExtPackInstalledEvent">IExtPackInstalledEvent</link>.
       </desc>
     </const>
@@ -27281,7 +27281,7 @@
     >
     <desc>Extension pack installed event.</desc>
-    <attribute name="filename" readonly="yes" type="wstring">
-      <desc>
-        Name of the extension pack install file.
+    <attribute name="name" readonly="yes" type="wstring">
+      <desc>
+        Name of the extension pack.
       </desc>
     </attribute>
Index: /trunk/src/VBox/Main/include/VirtualBoxImpl.h
===================================================================
--- /trunk/src/VBox/Main/include/VirtualBoxImpl.h	(revision 100729)
+++ /trunk/src/VBox/Main/include/VirtualBoxImpl.h	(revision 100730)
@@ -228,5 +228,5 @@
 
 #ifdef VBOX_WITH_EXTPACK
-    void i_onExtPackInstalled(const Utf8Str &aExtPackInstallFile);
+    void i_onExtPackInstalled(const Utf8Str &aExtPackName);
 #endif
 
Index: /trunk/src/VBox/Main/src-server/VirtualBoxImpl.cpp
===================================================================
--- /trunk/src/VBox/Main/src-server/VirtualBoxImpl.cpp	(revision 100729)
+++ /trunk/src/VBox/Main/src-server/VirtualBoxImpl.cpp	(revision 100730)
@@ -3792,7 +3792,7 @@
 
 #ifdef VBOX_WITH_EXTPACK
-void VirtualBox::i_onExtPackInstalled(const Utf8Str &aExtPackInstallFile)
-{
-    ::FireExtPackInstalledEvent(m->pEventSource, aExtPackInstallFile);
+void VirtualBox::i_onExtPackInstalled(const Utf8Str &aExtPackName)
+{
+    ::FireExtPackInstalledEvent(m->pEventSource, aExtPackName);
 }
 #endif