Index: trunk/src/VBox/VMM/Makefile.kmk
===================================================================
--- trunk/src/VBox/VMM/Makefile.kmk	(revision 100742)
+++ trunk/src/VBox/VMM/Makefile.kmk	(revision 100743)
@@ -252,5 +252,8 @@
  VBoxVMM_SOURCES += \
  	VMMAll/IEMAllThrdRecompiler.cpp \
- 	VMMAll/IEMAllThrdTables.cpp \
+ 	VMMAll/IEMAllThrdTables1.cpp \
+ 	VMMAll/IEMAllThrdTables2.cpp \
+ 	VMMAll/IEMAllThrdTables3.cpp \
+ 	VMMAll/IEMAllThrdTables4.cpp \
  	VMMAll/IEMAllThrdFuncs.cpp \
  	VMMAll/IEMAllThrdFuncsBltIn.cpp
@@ -576,5 +579,8 @@
  +| $(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedFunctions.h \
  +| $(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedFunctions.cpp.h \
- +| $(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions.cpp.h: \
+ +| $(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions1.cpp.h \
+ +| $(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions2.cpp.h \
+ +| $(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions3.cpp.h \
+ +| $(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions4.cpp.h: \
  		$(PATH_SUB_CURRENT)/VMMAll/IEMAllThrdPython.py \
  		$(PATH_SUB_CURRENT)/VMMAll/IEMAllInstPython.py \
@@ -599,8 +605,20 @@
        	--out-funcs-hdr "$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedFunctions.h.ts" \
        	--out-funcs-cpp "$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedFunctions.cpp.h.ts" \
-       	--out-mod-input "$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions.cpp.h.ts"
+       	--out-mod-input1 "$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions1.cpp.h.ts" \
+       	--out-mod-input2 "$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions2.cpp.h.ts" \
+       	--out-mod-input3 "$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions3.cpp.h.ts" \
+       	--out-mod-input4 "$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions4.cpp.h.ts"
 	$(QUIET)$(CP) -v -f --changed -- \
-		"$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions.cpp.h.ts" \
-		"$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions.cpp.h"
+		"$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions1.cpp.h.ts" \
+		"$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions1.cpp.h"
+	$(QUIET)$(CP) -v -f --changed -- \
+		"$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions2.cpp.h.ts" \
+		"$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions2.cpp.h"
+	$(QUIET)$(CP) -v -f --changed -- \
+		"$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions3.cpp.h.ts" \
+		"$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions3.cpp.h"
+	$(QUIET)$(CP) -v -f --changed -- \
+		"$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions4.cpp.h.ts" \
+		"$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions4.cpp.h"
 	$(QUIET)$(CP) -v -f --changed -- \
 		"$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedFunctions.cpp.h.ts" \
@@ -610,5 +628,8 @@
 		"$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedFunctions.h"
 	$(QUIET)$(RM) -f -- \
-		"$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions.cpp.h.ts" \
+		"$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions1.cpp.h.ts" \
+		"$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions2.cpp.h.ts" \
+		"$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions3.cpp.h.ts" \
+		"$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedInstructions4.cpp.h.ts" \
 		"$(VBoxVMM_0_OUTDIR)/CommonGenIncs/IEMThreadedFunctions.cpp.h.ts"
 
Index: trunk/src/VBox/VMM/VMMAll/IEMAllInstPython.py
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllInstPython.py	(revision 100742)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllInstPython.py	(revision 100743)
@@ -5374,15 +5374,15 @@
     return 0;
 
-## List of all main instruction files and their default maps.
-g_aasAllInstrFilesAndDefaultMap = (
-    ( 'IEMAllInstCommon.cpp.h',    'one',        ),
-    ( 'IEMAllInstOneByte.cpp.h',   'one',        ),
-    ( 'IEMAllInstTwoByte0f.cpp.h', 'two0f',      ),
-    ( 'IEMAllInstThree0f38.cpp.h', 'three0f38',  ),
-    ( 'IEMAllInstThree0f3a.cpp.h', 'three0f3a',  ),
-    ( 'IEMAllInstVexMap1.cpp.h',   'vexmap1',    ),
-    ( 'IEMAllInstVexMap2.cpp.h',   'vexmap2',    ),
-    ( 'IEMAllInstVexMap3.cpp.h',   'vexmap3',    ),
-    ( 'IEMAllInst3DNow.cpp.h',     '3dnow',      ),
+## List of all main instruction files, their default maps and file sets (-1 means included it all sets).
+g_aaoAllInstrFilesAndDefaultMapAndSet = (
+    ( 'IEMAllInstCommon.cpp.h',    'one',       -1, ),
+    ( 'IEMAllInstOneByte.cpp.h',   'one',        1, ),
+    ( 'IEMAllInst3DNow.cpp.h',     '3dnow',      2, ),
+    ( 'IEMAllInstTwoByte0f.cpp.h', 'two0f',      2, ),
+    ( 'IEMAllInstThree0f38.cpp.h', 'three0f38',  3, ),
+    ( 'IEMAllInstThree0f3a.cpp.h', 'three0f3a',  3, ),
+    ( 'IEMAllInstVexMap1.cpp.h',   'vexmap1',    4, ),
+    ( 'IEMAllInstVexMap2.cpp.h',   'vexmap2',    4, ),
+    ( 'IEMAllInstVexMap3.cpp.h',   'vexmap3',    4, ),
 );
 
@@ -5431,7 +5431,7 @@
         sName = os.path.split(sFilename)[1].lower();
         sMap  = None;
-        for asCur in g_aasAllInstrFilesAndDefaultMap:
-            if asCur[0].lower() == sName:
-                sMap = asCur[1];
+        for aoInfo in g_aaoAllInstrFilesAndDefaultMapAndSet:
+            if aoInfo[0].lower() == sName:
+                sMap = aoInfo[1];
                 break;
         if not sMap:
@@ -5449,5 +5449,5 @@
     Raises exception on failure.
     """
-    return __parseFilesWorker(g_aasAllInstrFilesAndDefaultMap);
+    return __parseFilesWorker([aoInfo[0:2] for aoInfo in g_aaoAllInstrFilesAndDefaultMapAndSet]);
 
 
Index: trunk/src/VBox/VMM/VMMAll/IEMAllIntprTables1.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllIntprTables1.cpp	(revision 100742)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllIntprTables1.cpp	(revision 100743)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * IEM - Instruction Decoding and Emulation - Interpreter Tables - One Byte.
+ * IEM - Instruction Decoding and Emulation - Interpreter Tables - One-Byte.
  */
 
Index: trunk/src/VBox/VMM/VMMAll/IEMAllIntprTables2.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllIntprTables2.cpp	(revision 100742)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllIntprTables2.cpp	(revision 100743)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * IEM - Instruction Decoding and Emulation - Interpreter Tables - Two byte & 3DNow!
+ * IEM - Instruction Decoding and Emulation - Interpreter Tables - Two-Byte & 3DNow!
  */
 
Index: trunk/src/VBox/VMM/VMMAll/IEMAllIntprTables3.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllIntprTables3.cpp	(revision 100742)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllIntprTables3.cpp	(revision 100743)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * IEM - Instruction Decoding and Emulation - Interpreter Tables - Three byte.
+ * IEM - Instruction Decoding and Emulation - Interpreter Tables - Three-Byte.
  */
 
Index: trunk/src/VBox/VMM/VMMAll/IEMAllThrdPython.py
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllThrdPython.py	(revision 100742)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllThrdPython.py	(revision 100743)
@@ -1186,4 +1186,5 @@
         self.oOptions        = None     # type: argparse.Namespace
         self.aoParsers       = []       # type: list(IEMAllInstPython.SimpleParser)
+        self.aidxFirstFunctions = []    # type: list(int) ##< Runs parallel to aoParser giving the index of the first function.
 
     #
@@ -1215,4 +1216,16 @@
                   % (cCount, dRawParamCounts.get(cCount, 0), dMinParamCounts.get(cCount, 0)),
                   file = sys.stderr);
+
+        # Populate aidxFirstFunctions.  This is ASSUMING that
+        # g_aoMcBlocks/self.aoThreadedFuncs are in self.aoParsers order.
+        iThreadedFunction       = 0;
+        oThreadedFunction       = self.getThreadedFunctionByIndex(0);
+        self.aidxFirstFunctions = [];
+        for oParser in self.aoParsers:
+            self.aidxFirstFunctions.append(iThreadedFunction);
+
+            while oThreadedFunction.oMcBlock.sSrcFile == oParser.sSrcFile:
+                iThreadedFunction += 1;
+                oThreadedFunction  = self.getThreadedFunctionByIndex(iThreadedFunction);
 
         return True;
@@ -1548,5 +1561,5 @@
         return ThreadedFunction.dummyInstance();
 
-    def generateModifiedInput(self, oOut):
+    def generateModifiedInput(self, oOut, idxFile):
         """
         Generates the combined modified input source/header file.
@@ -1559,14 +1572,25 @@
 
         #
-        # ASSUMING that g_aoMcBlocks/self.aoThreadedFuncs are in self.aoParsers
-        # order, we iterate aoThreadedFuncs in parallel to the lines from the
-        # parsers and apply modifications where required.
-        #
-        iThreadedFunction = 0;
-        oThreadedFunction = self.getThreadedFunctionByIndex(0);
-        for oParser in self.aoParsers: # type: IEMAllInstPython.SimpleParser
+        # Iterate all parsers (input files) and output the ones related to the
+        # file set given by idxFile.
+        #
+        for idxParser, oParser in enumerate(self.aoParsers): # type: int, IEMAllInstPython.SimpleParser
+            # Is this included in the file set?
+            sSrcBaseFile = os.path.basename(oParser.sSrcFile).lower();
+            fInclude     = -1;
+            for aoInfo in iai.g_aaoAllInstrFilesAndDefaultMapAndSet:
+                if sSrcBaseFile == aoInfo[0].lower():
+                    fInclude = aoInfo[2] in (-1, idxFile);
+                    break;
+            if fInclude is not True:
+                assert fInclude is False;
+                continue;
+
+            # Output it.
             oOut.write("\n\n/* ****** BEGIN %s ******* */\n" % (oParser.sSrcFile,));
 
-            iLine = 0;
+            iThreadedFunction = self.aidxFirstFunctions[idxParser];
+            oThreadedFunction = self.getThreadedFunctionByIndex(iThreadedFunction);
+            iLine             = 0;
             while iLine < len(oParser.asLines):
                 sLine = oParser.asLines[iLine];
@@ -1623,4 +1647,33 @@
         return True;
 
+    def generateModifiedInput1(self, oOut):
+        """
+        Generates the combined modified input source/header file, part 1.
+        Returns success indicator.
+        """
+        return self.generateModifiedInput(oOut, 1);
+
+    def generateModifiedInput2(self, oOut):
+        """
+        Generates the combined modified input source/header file, part 2.
+        Returns success indicator.
+        """
+        return self.generateModifiedInput(oOut, 2);
+
+    def generateModifiedInput3(self, oOut):
+        """
+        Generates the combined modified input source/header file, part 3.
+        Returns success indicator.
+        """
+        return self.generateModifiedInput(oOut, 3);
+
+    def generateModifiedInput4(self, oOut):
+        """
+        Generates the combined modified input source/header file, part 4.
+        Returns success indicator.
+        """
+        return self.generateModifiedInput(oOut, 4);
+
+
     #
     # Main
@@ -1639,5 +1692,6 @@
         oParser = argparse.ArgumentParser(add_help = False);
         oParser.add_argument('asInFiles',       metavar = 'input.cpp.h',        nargs = '*',
-                             default = [os.path.join(sScriptDir, asFM[0]) for asFM in iai.g_aasAllInstrFilesAndDefaultMap],
+                             default = [os.path.join(sScriptDir, aoInfo[0])
+                                        for aoInfo in iai.g_aaoAllInstrFilesAndDefaultMapAndSet],
                              help = "Selection of VMMAll/IEMAllInst*.cpp.h files to use as input.");
         oParser.add_argument('--out-funcs-hdr', metavar = 'file-funcs.h',       dest = 'sOutFileFuncsHdr', action = 'store',
@@ -1645,6 +1699,12 @@
         oParser.add_argument('--out-funcs-cpp', metavar = 'file-funcs.cpp',     dest = 'sOutFileFuncsCpp', action = 'store',
                              default = '-', help = 'The output C++ file for the functions.');
-        oParser.add_argument('--out-mod-input', metavar = 'file-instr.cpp.h',   dest = 'sOutFileModInput', action = 'store',
-                             default = '-', help = 'The output C++/header file for the modified input instruction files.');
+        oParser.add_argument('--out-mod-input1', metavar = 'file-instr.cpp.h',   dest = 'sOutFileModInput1', action = 'store',
+                             default = '-', help = 'The output C++/header file for modified input instruction files part 1.');
+        oParser.add_argument('--out-mod-input2', metavar = 'file-instr.cpp.h',   dest = 'sOutFileModInput2', action = 'store',
+                             default = '-', help = 'The output C++/header file for modified input instruction files part 2.');
+        oParser.add_argument('--out-mod-input3', metavar = 'file-instr.cpp.h',   dest = 'sOutFileModInput3', action = 'store',
+                             default = '-', help = 'The output C++/header file for modified input instruction files part 3.');
+        oParser.add_argument('--out-mod-input4', metavar = 'file-instr.cpp.h',   dest = 'sOutFileModInput4', action = 'store',
+                             default = '-', help = 'The output C++/header file for modified input instruction files part 4.');
         oParser.add_argument('--help', '-h', '-?', action = 'help', help = 'Display help and exit.');
         oParser.add_argument('--version', '-V', action = 'version',
@@ -1663,7 +1723,10 @@
             #
             aaoOutputFiles = (
-                 ( self.oOptions.sOutFileFuncsHdr, self.generateThreadedFunctionsHeader ),
-                 ( self.oOptions.sOutFileFuncsCpp, self.generateThreadedFunctionsSource ),
-                 ( self.oOptions.sOutFileModInput, self.generateModifiedInput ),
+                 ( self.oOptions.sOutFileFuncsHdr,  self.generateThreadedFunctionsHeader ),
+                 ( self.oOptions.sOutFileFuncsCpp,  self.generateThreadedFunctionsSource ),
+                 ( self.oOptions.sOutFileModInput1, self.generateModifiedInput1 ),
+                 ( self.oOptions.sOutFileModInput2, self.generateModifiedInput2 ),
+                 ( self.oOptions.sOutFileModInput3, self.generateModifiedInput3 ),
+                 ( self.oOptions.sOutFileModInput4, self.generateModifiedInput4 ),
             );
             fRc = True;
Index: trunk/src/VBox/VMM/VMMAll/IEMAllThrdTables.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllThrdTables.cpp	(revision 100742)
+++ 	(revision )
@@ -1,39 +1,0 @@
-/* $Id$ */
-/** @file
- * IEM - Instruction Decoding and Threaded Recompilation, Instruction Tables.
- */
-
-/*
- * Copyright (C) 2011-2023 Oracle and/or its affiliates.
- *
- * This file is part of VirtualBox base platform packages, as
- * available from https://www.virtualbox.org.
- *
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public License
- * as published by the Free Software Foundation, in version 3 of the
- * License.
- *
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, see <https://www.gnu.org/licenses>.
- *
- * SPDX-License-Identifier: GPL-3.0-only
- */
-
-#include "IEMAllThrdTables.h"
-
-/*
- * Include the "annotated" IEMAllInst*.cpp.h files.
- */
-#define IEM_WITH_ONE_BYTE_TABLE
-#define IEM_WITH_TWO_BYTE_TABLE
-#define IEM_WITH_THREE_BYTE_TABLES
-#define IEM_WITH_3DNOW_BYTE_TABLE
-#define IEM_WITH_VEX_TABLES
-#include "IEMThreadedInstructions.cpp.h"
-
Index: trunk/src/VBox/VMM/VMMAll/IEMAllThrdTables1.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllThrdTables1.cpp	(revision 100743)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllThrdTables1.cpp	(revision 100743)
@@ -0,0 +1,35 @@
+/* $Id$ */
+/** @file
+ * IEM - Instruction Decoding and Threaded Recompilation, Instruction Tables - One-Byte.
+ */
+
+/*
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
+ *
+ * This file is part of VirtualBox base platform packages, as
+ * available from https://www.virtualbox.org.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation, in version 3 of the
+ * License.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <https://www.gnu.org/licenses>.
+ *
+ * SPDX-License-Identifier: GPL-3.0-only
+ */
+
+#include "IEMAllThrdTables.h"
+
+/*
+ * Include the "annotated" IEMAllInst*.cpp.h files.
+ */
+#define IEM_WITH_ONE_BYTE_TABLE
+#include "IEMThreadedInstructions1.cpp.h"
+
Index: trunk/src/VBox/VMM/VMMAll/IEMAllThrdTables2.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllThrdTables2.cpp	(revision 100743)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllThrdTables2.cpp	(revision 100743)
@@ -0,0 +1,36 @@
+/* $Id$ */
+/** @file
+ * IEM - Instruction Decoding and Threaded Recompilation, Instruction Tables - Two-Byte & 3DNow!
+ */
+
+/*
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
+ *
+ * This file is part of VirtualBox base platform packages, as
+ * available from https://www.virtualbox.org.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation, in version 3 of the
+ * License.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <https://www.gnu.org/licenses>.
+ *
+ * SPDX-License-Identifier: GPL-3.0-only
+ */
+
+#include "IEMAllThrdTables.h"
+
+/*
+ * Include the "annotated" IEMAllInst*.cpp.h files.
+ */
+#define IEM_WITH_TWO_BYTE_TABLE
+#define IEM_WITH_3DNOW_BYTE_TABLE
+#include "IEMThreadedInstructions2.cpp.h"
+
Index: trunk/src/VBox/VMM/VMMAll/IEMAllThrdTables3.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllThrdTables3.cpp	(revision 100743)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllThrdTables3.cpp	(revision 100743)
@@ -0,0 +1,35 @@
+/* $Id$ */
+/** @file
+ * IEM - Instruction Decoding and Threaded Recompilation, Instruction Tables - Three-Byte.
+ */
+
+/*
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
+ *
+ * This file is part of VirtualBox base platform packages, as
+ * available from https://www.virtualbox.org.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation, in version 3 of the
+ * License.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <https://www.gnu.org/licenses>.
+ *
+ * SPDX-License-Identifier: GPL-3.0-only
+ */
+
+#include "IEMAllThrdTables.h"
+
+/*
+ * Include the "annotated" IEMAllInst*.cpp.h files.
+ */
+#define IEM_WITH_THREE_BYTE_TABLES
+#include "IEMThreadedInstructions3.cpp.h"
+
Index: trunk/src/VBox/VMM/VMMAll/IEMAllThrdTables4.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllThrdTables4.cpp	(revision 100743)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllThrdTables4.cpp	(revision 100743)
@@ -0,0 +1,35 @@
+/* $Id$ */
+/** @file
+ * IEM - Instruction Decoding and Threaded Recompilation, Instruction Tables - VEX.
+ */
+
+/*
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
+ *
+ * This file is part of VirtualBox base platform packages, as
+ * available from https://www.virtualbox.org.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation, in version 3 of the
+ * License.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <https://www.gnu.org/licenses>.
+ *
+ * SPDX-License-Identifier: GPL-3.0-only
+ */
+
+#include "IEMAllThrdTables.h"
+
+/*
+ * Include the "annotated" IEMAllInst*.cpp.h files.
+ */
+#define IEM_WITH_VEX_TABLES
+#include "IEMThreadedInstructions4.cpp.h"
+